package host;

import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import javax.swing.ImageIcon;
import javax.comm.PortInUseException;
import javax.comm.UnsupportedCommOperationException;
import javax.imageio.*;
import javax.swing.JOptionPane;

/*
 * Panel.java
 *
 * Created on Jul 20, 2008, 1:13:12 PM
 */

/**
 * Panel class, GUI
 * @author bentzx
 */
public class Panel extends javax.swing.JPanel {

	private static final long serialVersionUID = 1L;
	private SerialManager serialManager_;
	private Recorder recorder_;
	private boolean isConnected_ = false;
	private boolean isRecording_ = false;
	private boolean isPlaying_ = false; 
	
    /** Creates new form Panel 
     * @throws IOException */
    public Panel(SerialManager sM) throws IOException {
        serialManager_ = sM;
    	initComponents();
    	addListeners();
    	ImageIcon display = new ImageIcon("startupImg.jpg", "Display video");
        picWindowLabel_.setIcon(display);
        recorder_ = new Recorder(this);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">
    private void initComponents() {

        topPanel_ = new javax.swing.JPanel();
        picWindowLabel_ = new javax.swing.JLabel();
        statusPanel_ = new javax.swing.JPanel();
        statusTF_ = new javax.swing.JTextField();
        controlsPanel_ = new javax.swing.JPanel();
        connectionLabel_ = new javax.swing.JLabel();
        recButton_ = new javax.swing.JButton();
        playButton_ = new javax.swing.JButton();
        playlistComboBox_ = new javax.swing.JComboBox();
        connectButton_ = new javax.swing.JButton();
        deleteButton_ = new javax.swing.JButton();

        topPanel_.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Display", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 0, 11), new java.awt.Color(0, 153, 255))); // NOI18N

        javax.swing.GroupLayout topPanel_Layout = new javax.swing.GroupLayout(topPanel_);
        topPanel_.setLayout(topPanel_Layout);
        topPanel_Layout.setHorizontalGroup(
            topPanel_Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(topPanel_Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(picWindowLabel_, javax.swing.GroupLayout.PREFERRED_SIZE, 248, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        topPanel_Layout.setVerticalGroup(
            topPanel_Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(topPanel_Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(picWindowLabel_, javax.swing.GroupLayout.PREFERRED_SIZE, 192, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        statusPanel_.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Status", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 0, 11), new java.awt.Color(0, 153, 255))); // NOI18N

        statusTF_.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                statusTF_ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout statusPanel_Layout = new javax.swing.GroupLayout(statusPanel_);
        statusPanel_.setLayout(statusPanel_Layout);
        statusPanel_Layout.setHorizontalGroup(
            statusPanel_Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(statusPanel_Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(statusTF_, javax.swing.GroupLayout.PREFERRED_SIZE, 251, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(7, Short.MAX_VALUE))
        );
        statusPanel_Layout.setVerticalGroup(
            statusPanel_Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, statusPanel_Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(statusTF_, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        controlsPanel_.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Controls", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 0, 11), new java.awt.Color(0, 153, 255))); // NOI18N

        connectionLabel_.setBackground(java.awt.Color.red);
        connectionLabel_.setForeground(java.awt.Color.red);
        connectionLabel_.setOpaque(true);

        recButton_.setText("Rec");
        recButton_.setEnabled(false);
        recButton_.setMaximumSize(new java.awt.Dimension(60, 23));
        recButton_.setMinimumSize(new java.awt.Dimension(60, 23));
        recButton_.setPreferredSize(new java.awt.Dimension(60, 23));

        playButton_.setText("Play");
        playButton_.setEnabled(false);
        playButton_.setMaximumSize(new java.awt.Dimension(60, 23));
        playButton_.setMinimumSize(new java.awt.Dimension(60, 23));
        playButton_.setPreferredSize(new java.awt.Dimension(60, 23));

        playlistComboBox_.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Select and play", " ", " " }));

        connectButton_.setText("Connect");
        connectButton_.setMaximumSize(new java.awt.Dimension(100, 23));
        connectButton_.setMinimumSize(new java.awt.Dimension(100, 23));
        connectButton_.setPreferredSize(new java.awt.Dimension(100, 23));

        deleteButton_.setText("Delete");
        deleteButton_.setEnabled(false);
        deleteButton_.setMaximumSize(new java.awt.Dimension(60, 23));
        deleteButton_.setMinimumSize(new java.awt.Dimension(60, 23));
        deleteButton_.setPreferredSize(new java.awt.Dimension(60, 23));

        javax.swing.GroupLayout controlsPanel_Layout = new javax.swing.GroupLayout(controlsPanel_);
        controlsPanel_.setLayout(controlsPanel_Layout);
        controlsPanel_Layout.setHorizontalGroup(
            controlsPanel_Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(controlsPanel_Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(controlsPanel_Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(controlsPanel_Layout.createSequentialGroup()
                        .addComponent(recButton_, javax.swing.GroupLayout.PREFERRED_SIZE, 71, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(playButton_, javax.swing.GroupLayout.DEFAULT_SIZE, 71, Short.MAX_VALUE)
                        .addGap(18, 18, 18)
                        .addComponent(deleteButton_, javax.swing.GroupLayout.PREFERRED_SIZE, 70, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(controlsPanel_Layout.createSequentialGroup()
                        .addComponent(connectButton_, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(30, 30, 30)
                        .addComponent(connectionLabel_, javax.swing.GroupLayout.PREFERRED_SIZE, 118, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(playlistComboBox_, 0, 248, Short.MAX_VALUE))
                .addContainerGap())
        );
        controlsPanel_Layout.setVerticalGroup(
            controlsPanel_Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(controlsPanel_Layout.createSequentialGroup()
                .addGroup(controlsPanel_Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(controlsPanel_Layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(controlsPanel_Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(connectionLabel_, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(connectButton_, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                    .addGroup(controlsPanel_Layout.createSequentialGroup()
                        .addGap(52, 52, 52)
                        .addComponent(playlistComboBox_, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(18, 18, 18)
                .addGroup(controlsPanel_Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(recButton_, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(deleteButton_, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(playButton_, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(controlsPanel_, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(topPanel_, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(statusPanel_, 0, 280, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(topPanel_, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(statusPanel_, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(controlsPanel_, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
    }// </editor-fold>    

    private void statusTF_ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        // TODO add your handling code here:
}                                         

    /**
     * Connect to serial port
     * When connected: button says Disconnect, recButton_ enabled, statusTF_ and connectionLabel_ display status
     * @throws PortInUseException 
     * @throws UnsupportedCommOperationException 
     * @throws IOException 
     */
    private void connectButton_ActionPerformed(java.awt.event.ActionEvent evt) throws IOException, UnsupportedCommOperationException, PortInUseException{
    	if (connectButton_.getText().equals("Connect")){
    		statusTF_.setText("Connecting...");
    		connectionLabel_.setBackground(java.awt.Color.yellow);	// change connection color to yellow
    		isConnected_ = serialManager_.enableSerial();
    	} else {
    		if (isRecording_){
    			isRecording_=false;
    			recorder_.stop();	//stop recording if still recording
    		}
    		isConnected_ = serialManager_.disconnect();
    	}
    	recButton_.setEnabled(isConnected_);	// enabled only when serial connection is active
    	if (isConnected_){
    		//isConnected_ = serialManager_.converse();
    		
    		connectButton_.setText("Disconnect");
    		statusTF_.setText("Connected. Serial connection is active.");
    		connectionLabel_.setBackground(java.awt.Color.green);
    		recButton_.setText("Rec");
            
    	} else {
    		connectButton_.setText("Connect");
    		statusTF_.setText("Serial communication is disconnected.");
    		connectionLabel_.setBackground(java.awt.Color.red);
    		isRecording_ = false;
    	}
    }
    
    /**
     * Handles rec button behavior
     * @param evt Action event
     */
    private void recButton_ActionPerformed(java.awt.event.ActionEvent evt){
    	if (isRecording_){
    		recButton_.setText("Rec");
    		statusTF_.setText("Recording stopped");
    		isRecording_ = false;
    		recorder_.stop();
    	} else {
    		recButton_.setText("Stop");
    		statusTF_.setText("Recording");
    		isRecording_ = true;
    		recorder_.start();
    	}
    	
    }
    
    /**
     * Handles play button behavior
     * @param evt Action event
     */
    private void playButton_ActionPerformed(java.awt.event.ActionEvent evt){
    	if (isPlaying_){
    		playButton_.setText("Play");
    		statusTF_.setText("Playback stopped");
    		isPlaying_ = false;
    		
    	} else {
    		playButton_.setText("Stop");
    		statusTF_.setText("Playing");
    		isPlaying_ = true;
    		String playSelected = (String)playlistComboBox_.getSelectedItem();
    		PlayThread play = new PlayThread(recorder_, playSelected); //use new thread, otherwise button and awt hangs until completed initDisplay
    		play.start();
    	}
    } 
    
    /**
     * Handles playlist comboBox pop up behavior
     * @param evt Action event
     */
    private void playlistComboBox_Popup(javax.swing.event.PopupMenuEvent evt){
    	updatePlaylist();
    }
    
    /**
     * Handles playlist comboBox close behavior
     * @param evt Action event
     */
    private void playlistComboBox_PopupClosed(javax.swing.event.PopupMenuEvent evt){
    	if (playlistComboBox_.getSelectedItem().equals("Select and play")){ //disable the play and delete buttons if no recording selected
    		playButton_.setEnabled(false);
    		deleteButton_.setEnabled(false);
    	} else {
    		playButton_.setEnabled(true);
    		deleteButton_.setEnabled(true);
    	}
    }
    
    /**
     * Handles delete button event
     * @param evt Action event
     */
    private void deleteButton_ActionPerformed(java.awt.event.ActionEvent evt){
    	int proceed;
    	proceed = JOptionPane.showConfirmDialog(null, "Do you really want to delete selected recording?");
    	if(proceed==JOptionPane.YES_OPTION){
    		recorder_.deleteFolder((String)playlistComboBox_.getSelectedItem());
    	}
    }
    
    /**
     * Add remaining listeners to action-listening-components, note statusTF_ already added
     */
    private void addListeners() {
    	connectButton_.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                try {
					connectButton_ActionPerformed(evt);
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (UnsupportedCommOperationException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (PortInUseException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
            }
        });
    	
    	recButton_.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                recButton_ActionPerformed(evt);
            }
        });
    	playButton_.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                playButton_ActionPerformed(evt);
            }
        });
    	playlistComboBox_.addPopupMenuListener(new javax.swing.event.PopupMenuListener() {
            public void popupMenuWillBecomeVisible(javax.swing.event.PopupMenuEvent evt) {
                playlistComboBox_Popup(evt);
            }
            public void popupMenuWillBecomeInvisible(javax.swing.event.PopupMenuEvent evt) {
            	playlistComboBox_PopupClosed(evt);
            }
            public void popupMenuCanceled(javax.swing.event.PopupMenuEvent evt) {}
        });
    	deleteButton_.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteButton_ActionPerformed(evt);
            }
        });
    }
    
    /**
     * Refreshes display
     * @param input Bitmap file
     */
    protected void initDisplay(File input){
//    	File input = new File("recordings/temp.bmp");	//create file for the bitmap
    	BufferedImage image;
		try {
			//image = flipV(rotate90SX(ImageIO.read(input)));
//			System.out.println("try init display");
			image = flipH(ImageIO.read(input));
			File output = new File("recordings/image.jpg");	//create a file for the output
	    	ImageIO.write(image, "jpg", output);	//write the image to the destination as jpg
	    	ImageIcon display = new ImageIcon(ImageIO.read(output)); //use ImageIO.read cos no caching, otherwise JLabel.setIcon won't update
	        picWindowLabel_.setIcon(display);
//	        output.delete();
	        if (isRecording_){
	        	recorder_.store(input);
	        }
		} catch (IOException e) {
			// TODO Auto-generated catch block
			System.out.println("cannot display");
			e.printStackTrace();
		}
    	
    }
    
    /**
     * Rotate image 90 degrees clockwise
     * @param bi
     * @return
     */
//    private BufferedImage rotate90DX(BufferedImage bi){
//    	int width = bi.getWidth();
//    	int height = bi.getHeight();
//    	BufferedImage biFlip = new BufferedImage(height, width, bi.getType());
//    	for(int i=0; i<width; i++){
//    		for(int j=0; j<height; j++){
//    			biFlip.setRGB(height-1-j, width-1-i, bi.getRGB(i, j));
//    		}
//    	}
//    	return biFlip;
//    }
    
    /**
     * Rotate image 90 degrees counterclockwise
     * @param bi
     * @return
     */
//    private BufferedImage rotate90SX(BufferedImage bi){
//    	int width = bi.getWidth();
//    	int height = bi.getHeight();
//    	BufferedImage biFlip = new BufferedImage(height, width, bi.getType());
//    	for(int i=0; i<width; i++){
//    		for(int j=0; j<height; j++){
//    			biFlip.setRGB(j, i, bi.getRGB(i, j));
//    		}
//    	}
//    	return biFlip;
//    }
    
    /**
     * Flip image vertically
     * @param bi
     * @return
     */
//    private BufferedImage flipV(BufferedImage bi) {
//        int width = bi.getWidth();
//        int height = bi.getHeight();
//        BufferedImage biFlip = new BufferedImage(width, height, bi.getType());
//        for(int i=0; i<width; i++)
//            for(int j=0; j<height; j++)
//                biFlip.setRGB(i, (height-1)-j, bi.getRGB(i, j));
//        return biFlip;
//    }
    
    /**
     * Flip image horizontally
     * @param bi BufferedImage		
     * @return The horizontally flipped image
     */
    private BufferedImage flipH(BufferedImage bi) {
        int width = bi.getWidth();
        int height = bi.getHeight();
        BufferedImage biFlip = new BufferedImage(width, height, bi.getType());
        for(int i=0; i<width; i++)
            for(int j=0; j<height; j++)
                biFlip.setRGB((width-1)-i, j, bi.getRGB(i, j));
        return biFlip;
    }

    protected void testRecorder(){
    	recorder_.start();
		recorder_.store(new File("recordings\\temp.bmp"));
		recorder_.store(new File("recordings\\temp2.bmp"));
		recorder_.store(new File("recordings\\picTest4.bmp"));
		recorder_.stop();
		recorder_.start();
		recorder_.store(new File("recordings\\picTest5.bmp"));
		recorder_.stop();
		File [] folders = recorder_.getRecFolders();
		for (int i=0; i<folders.length; i++){
			System.out.println("folder names " + i + ": " + folders[i].getName());
			recorder_.retrieve(folders[i].getName());
		}
    }
    
    /**
     * Updates recordings playlist
     */
    protected void updatePlaylist(){
    	playlistComboBox_.removeAllItems();
    	playlistComboBox_.addItem("Select and play");
    	File [] folders = recorder_.getRecFolders();
    	for (int i=0; i<folders.length; i++){
    		String folderName = folders[i].getName();
    		playlistComboBox_.addItem(folderName);
    	}
    }
    
    /**
     * Check if playing
     * @return Boolean if it's playing 
     */
    protected boolean getIsPlaying(){
    	return isPlaying_;
    }
    
    /**
     * To get statusTF_
     * @return statusTF_
     */
    protected javax.swing.JTextField getStatusTF(){
    	return statusTF_;
    }
    

    
    // Variables declaration - do not modify
    private javax.swing.JButton connectButton_;
    private javax.swing.JLabel connectionLabel_;
    private javax.swing.JPanel controlsPanel_;
    private javax.swing.JButton deleteButton_;
    private javax.swing.JLabel picWindowLabel_;
    private javax.swing.JButton playButton_;
    private javax.swing.JComboBox playlistComboBox_;
    private javax.swing.JButton recButton_;
    private javax.swing.JPanel statusPanel_;
    private javax.swing.JTextField statusTF_;
    private javax.swing.JPanel topPanel_;
    // End of variables declaration                   

}

/**
 * Requires this thread for play, otherwise, GUI freezes
 * @author bentzx
 *
 */
class PlayThread extends Thread {
	private Recorder recorder_;
	private String playlistSelected_;
	
	public PlayThread(Recorder rec, String s){
		recorder_ = rec;
		playlistSelected_ = s;
	}

	public void run() {
		recorder_.retrieve(playlistSelected_);
	}
}